jQuery(document).ready(function($){
  function getFileList(){
    var files_obj, chats_obj;

    var data = {
      'action': 'elementary_addon_html_upload_ajax',
      'file_list': 1
    };
    $.post(ajaxurl, data, function(response) {
      res = response.replace(']0', ']')
      files_obj = JSON.parse(res);
      // console.log('files_obj: ', files_obj);

      var data2 = {
        'action': 'elementary_addon_html_upload_ajax',
        'chats_list': 1
      };
      $.post(ajaxurl, data2, function(response2) {
        res = response2.replace(']0', ']')
        chats_obj = JSON.parse(res);
        // console.log('chats_obj: ', chats_obj);

        $('.elementary_addons_settings .files_container').empty();

        if(typeof(files_obj) !== 'undefined'){
          for (var i = 0; i < files_obj.length; i++) {

            var item = '';
            item += '<div class="item">';
            item += '<img ' +
            'data-eafree-iframe-url="' + files_obj[i].url + '"' +
            'class="solid_preview"' +
            'src="' + files_obj[i].placeholder + '"' +
            'width="300px"' +
            'height="200px"' +
            '>';
            item += '<div class="item_content">';
            item += '<span>' + files_obj[i].name + '</span>';
            item += '<span data-eafree-file="' + files_obj[i].name + '.php" class="dashicons-before dashicons-trash delete"> Delete</span>';
            if(typeof(chats_obj) !== 'undefined' && chats_obj.length > 0){
              item += '<select class="chats_select" name="" data-eafree-file-name="' + files_obj[i].name + '">';
              item += '<option value="none">Select Chat</option>';
              for (var ii = 0; ii < chats_obj.length; ii++) {
                var selected = (files_obj[i].chat === chats_obj[ii]) ? 'selected="selected"' : '';
                item += '<option ' + selected + ' value="' + chats_obj[ii] + '">' + chats_obj[ii] + '</option>';
              }
              item += '</select>';
            }
            item += '</div></div>';

            $('.elementary_addons_settings .files_container').prepend(item);
          }
        }
      });
    });






  }
  if($('.elementary_addons_settings').length > 0 ){
    getFileList();
  }


  $('.elementary_addons_settings .file_upload form button').on('click', function(e){
    files2 = $('#elementary_addons_solid_file').prop('files');
    e.preventDefault();
    if(typeof(files2) !== "undefined"){

      data = new FormData();

      for (var i = 0; i < files2.length; i++) {
        var file = files2[i];
        data.append('elementary_addons_solid_file[]', file, file.name);
      }
      data.append('action', 'elementary_addon_html_upload_ajax');

      jQuery.ajax({
        xhr: function () {
          var xhr = new window.XMLHttpRequest();
          xhr.upload.addEventListener("progress", function (evt) {
            if (evt.lengthComputable) {
              var percentComplete = Math.round((evt.loaded / evt.total) * 100);
              $('.elementary_addons_settings .prog_bar_bg').addClass('visible');
              $('.elementary_addons_settings .prog_bar').css('width', percentComplete + "%");
            }
          }, false);
          xhr.addEventListener("progress", function (evt) {
            if (evt.lengthComputable) {
              var percentComplete = Math.round((evt.loaded / evt.total) * 100);
              $('.elementary_addons_settings .prog_bar_bg').addClass('visible');
              $('.elementary_addons_settings .prog_bar').css('width', percentComplete + "%");
            }
          }, false);
          return xhr;
        },
        success: function(response){
          // console.log('response: ', response);
          $('.elementary_addons_settings .prog_bar_bg').removeClass('visible');
          getFileList();
        },
        error: function(err){
          throw err;
        },
        type: "post",
        url: ajaxurl,
        data: data,

        dataType: "html",

        enctype: 'multipart/form-data',

        processData: false,
        contentType: false,

      }).done(function(msg){
        // console.log('done: ', msg);
        getFileList();
      }).fail(function(err){
        alert('Upload failed, try uploading fewer files, or set max_upload_size and max_post_size to higher values');
        throw err;
      });

    }
  });// end form button click

  $(document).on('click', '.elementary_addons_settings .files_container .delete', function(){

    var file = $(this).attr('data-eafree-file');
    var data = {
      'action': 'elementary_addon_html_upload_ajax',
      'single_del_file': file
    };
    var sure_wrap = $('.elementary_addons_settings .sure_wrapper');

    sure_wrap.addClass('visible');
    $('.no', sure_wrap).addClass('delete_file');
    $('.yes', sure_wrap).addClass('delete_file');
    $('.yes.delete_file', sure_wrap).on('click', function(){
      sure_wrap.removeClass('visible');
      $('.no', sure_wrap).removeClass('delete_file');
      $('.yes', sure_wrap).removeClass('delete_file');
      $.post(ajaxurl, data, function(response) {
        // console.log('deleted: ', response);
        getFileList();
      }).fail(function() {
        alert( "error" );
      });
    });

    $('.no.delete_file', sure_wrap).on('click', function(){
      sure_wrap.removeClass('visible');
      $('.no', sure_wrap).removeClass('delete_file');
      $('.yes', sure_wrap).removeClass('delete_file');
    });
  });

  $(document).on('click', '.elementary_addons_settings .solid_preview', function(){
    var file_url = $(this).attr('data-eafree-iframe-url');
    $(this).parent().prepend('<iframe src="' + file_url + '"/>')
    $(this).css('display', 'none');

  });

  var slug = function(str) {
    var $slug = '';
    var trimmed = $.trim(str);
    $slug = trimmed.replace(/[^a-z0-9-]/gi, '-').
    replace(/-+/g, '_');
    // replace(/^_|_$/g, '');
    return $slug.toLowerCase();
  }

  $('.elementary_addons_settings .chats form input[type="text"]').on('change keyup input', function(){
    $(this).val(slug($(this).val()));
  });

  $('.elementary_addons_settings .chats form button').on('click', function(e){
    e.preventDefault();
    var chat_slug = $('+ input[type=text]', this).val();
    var data = {
      'action': 'elementary_addon_html_upload_ajax',
      'eafree_add_chat': chat_slug
    };
    $.post(ajaxurl, data, function(response) {
      // console.log('added chats: ', response);
      getFileList();
    }).fail(function() {
      alert( "error" );
    });
  });

  $(document).on('change', '.elementary_addons_settings .files_container .chats_select', function(){
    var filename = $(this).attr('data-eafree-file-name');
    var selected_chat = $('option:selected', this).val();
    var data = {
      'action': 'elementary_addon_html_upload_ajax',
      'eafree_select_chat': 1,
      'eafree_selected_chat': selected_chat,
      'eafree_file_name': filename
    };
    $.post(ajaxurl, data, function(response) {
      // console.log('selected chat: ', response);
    }).fail(function() {
      alert( "error" );
    });
  });

  ///////////////////////////// EDIT CHATS //////////////////////////////
  $('.elementary_addons_settings .edit_chats').on('click', function(){
    $('~ .edit_chats_wrapper', this).toggleClass('visible');
  });

  $('.elementary_addons_settings .close_edit_chats').on('click', function(){
    $(this).parent().parent().toggleClass('visible');
  });

  $('.elementary_addons_settings .delete_chats').on('click', function(){
    var to_delete = [];
    var inputs = $('.elementary_addons_settings .edit_chats_items input[type="checkbox"]');
    var labels = $('.elementary_addons_settings .edit_chats_items input[type="checkbox"] + label');

    if($('.elementary_addons_settings .edit_chats_items input:checkbox:checked').length > 0){
      var sure_wrap = $('.elementary_addons_settings .sure_wrapper');
      sure_wrap.addClass('visible');
      $('.yes', sure_wrap).addClass('delete_chats');
      $('.no', sure_wrap).addClass('delete_chats');
      $('.yes.delete_chats', sure_wrap).on('click', function(){

        sure_wrap.removeClass('visible');
        $('.yes', sure_wrap).removeClass('delete_chats');
        $('.no', sure_wrap).removeClass('delete_chats');
        for (var i = 0; i < inputs.length; i++) {
          if(inputs.eq(i).is(':checked')){
            var val = $(inputs).eq(i).val();
            to_delete.push(val);
            $(inputs).eq(i).remove();
            $(labels).eq(i).find(' + br').remove();
            $(labels).eq(i).remove();
          }
        }

        var json_chats = JSON.stringify(to_delete);
        // console.log('json_chats: ', json_chats);
        var data = {
          'action': 'elementary_addon_html_upload_ajax',
          'eafree_delete_chats': json_chats,
        };
        $.post(ajaxurl, data, function(response) {
          // console.log('deleted chat: ', response);
        }).fail(function() {
          alert( "error" );
        });
      });

      $('.no.delete_chats', sure_wrap).on('click', function(){
        sure_wrap.removeClass('visible');
        $('.yes', sure_wrap).removeClass('delete_chats');
        $('.no', sure_wrap).removeClass('delete_chats');
      });
    }


  });

  ///////////////////////////////// save settings //////////////////////////
  $('.eafree_save_settings').on('click', function(){
    var $this = $(this);
    $('.eafree_spinner', this).addClass('visible');
    var switches = $(this).parent().parent().find('.switch_list .switch_container');
    // console.log('switches: ', switches);
    var options = {};
    for (var i = 0; i < switches.length; i++) {
      var name = switches.eq(i).find('input').attr('name');
      if(switches.eq(i).find('input').is(':checked')){
        options[name] = 'yes';
      }
      else{
        options[name] = '';
      }
    }

    var text_fields = $(this).closest('.elementary_addons_settings').find('input[type="text"]');

    for (var i = 0; i < text_fields.length; i++) {
      var name = text_fields.eq(i).attr('name');
      var key_val = text_fields.eq(i).val();
      options[name] = key_val;
    }

    var json_settings = JSON.stringify(options);
    // console.log('options: ', options);

    var data = {
      'action': 'elementary_addons_manage_settings',
      'eafree_saved_settings': json_settings,
    };
    $.post(ajaxurl, data, function(response) {
      // console.log('settings saved: ', response);
      $('.eafree_spinner', $this).removeClass('visible');
    }).fail(function() {
      alert( "error" );
    });
  });
});
