<?php
class EAFREE_Toggle_Switch {

  public $args_arr;

  public function __construct(){
    // $this->args_arr = $args_arr;
  }

  public function create( $args_arr ){
    ?>
    <div class="switch_list">
      <?php
      for ( $i = 0; $i < count( $args_arr ); $i++ ):
        $check = ( $args_arr[$i]['checked'] === 'yes' ) ? 'checked="checked"' : '';
        ?>
        <div class="switch_container" style="display:<?php echo esc_attr( $args_arr[$i]['display'] ); ?>;">
          <h3><?php echo esc_html( $args_arr[$i]['title'] ); ?></h3>
          <div class="switch_wrap">
            <span><?php echo esc_html( $args_arr[$i]['before_txt'] ); ?></span>
            <label class="switch">
              <input type="checkbox" <?php echo $check ?> value="yes" name="<?php echo esc_attr( $args_arr[$i]['name'] ); ?>">
              <span class="slider round"></span>
            </label>
            <span><?php echo esc_html( $args_arr[$i]['after_txt'] ); ?></span>
          </div>
        </div>
        <?php
      endfor;
      ?>
    </div>
    <?php
  }
}
?>
