<?php
$sett = new EAFREE_Get_Settings();
$settings = $sett->get_settings();

$args = array(

  array(
    'title' => esc_html__( 'Enable Lottie Animation: ', 'elementary-addons' ),
    'before_txt' => esc_html__( 'No', 'elementary-addons' ),
    'after_txt' => esc_html__( 'Yes', 'elementary-addons' ),
    'checked' => $settings['enable_lottie'] ?? 'yes',
    'display' => 'inline-block',
    'name' => 'enable_lottie',
  ),

  array(
    'title' => esc_html__( 'Enable dotLottie Animation: ', 'elementary-addons' ),
    'before_txt' => esc_html__( 'No', 'elementary-addons' ),
    'after_txt' => esc_html__( 'Yes', 'elementary-addons' ),
    'checked' => $settings['enable_dotlottie'] ?? 'yes',
    'display' => 'inline-block',
    'name' => 'enable_dotlottie',
  ),

  array(
    'title' => esc_html__( 'Enable Vertical Accordion: ', 'elementary-addons' ),
    'before_txt' => esc_html__( 'No', 'elementary-addons' ),
    'after_txt' => esc_html__( 'Yes', 'elementary-addons' ),
    'checked' => $settings['enable_vertical_accordion'] ?? 'yes',
    'display' => 'inline-block',
    'name' => 'enable_vertical_accordion',
  ),

  array(
    'title' => esc_html__( 'Enable Simple Menu: ', 'elementary-addons' ),
    'before_txt' => esc_html__( 'No', 'elementary-addons' ),
    'after_txt' => esc_html__( 'Yes', 'elementary-addons' ),
    'checked' => $settings['enable_simple_menu'] ?? 'yes',
    'display' => 'inline-block',
    'name' => 'enable_simple_menu',
  ),

  array(
    'title' => esc_html__( 'Enable Dynamic Button: ', 'elementary-addons' ),
    'before_txt' => esc_html__( 'No', 'elementary-addons' ),
    'after_txt' => esc_html__( 'Yes', 'elementary-addons' ),
    'checked' => $settings['enable_dynamic_button'] ?? 'yes',
    'display' => 'inline-block',
    'name' => 'enable_dynamic_button',
  ),

);

?>
<div class="">

  <h2><?php echo esc_html__( 'General', 'elementary-addons' ); ?></h2>
  <?php
  $toggle = new EAFREE_Toggle_Switch();
  $toggle->create( $args );
  ?>

  <?php
  $toggle = new EAFREE_Save_Settings_Button();
  $toggle->create( [] );
  ?>

</div>
